<?php

	define('IN_PHPBB', true);
	$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
	$phpEx = substr(strrchr(__FILE__, '.'), 1);
	require($phpbb_root_path . 'common.' . $phpEx);

$buzerconfig = array(
	'in' 		=> "viewtopic.php",
	'out' 	=> "viewtopic_buzer.php",
	'backup'	=> "viewtopic_buzer_org.php",
	'buzer'	=> "buzer_phpbb3.php",
	'errors'	=> array(),
	'msgs'	=> array(),
	'content' => "",
	'incl' 	=> "",
	'set'	 	=> "",
	'charset'	=> "",
);



if ( isset($_GET['install']) and preg_match("/^1$/", $request->variable('install', 0))) {
	# Installation
	
	if ( isset($_GET['charset']) and preg_match("/^([a-z0-9\-]+)$/i", $request->variable('charset', ''), $treffer) ) {
		$buzerconfig['charset'] = $treffer[1];
	} else {
		$buzerconfig['charset'] = "utf-8";
	}
	array_push($buzerconfig['msgs'], "verwende '$buzerconfig[charset]'");
	
	
	$install = "Installation " . (install($buzerconfig) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( isset($_GET['deinstall']) and preg_match("/^1$/", $request->variable('deinstall', 0))) {
	# Deinstallation
	
	
	$deinstall = "Deinstallation " . (deinstall($buzerconfig) ? "" : "nicht ") . "erfolgreich<br />";

}

if ( count($buzerconfig['errors'])) {
	$error 	= '<b>aufgetretene Fehler:</b><div style="color:red;">' . implode( '<br />', $buzerconfig['errors']) . '</div>';
}

if ( count($buzerconfig['msgs'])) {
	$msg 	= '<b>Ablauf:</b><div style="color:green;">' . implode( '<br />', $buzerconfig['msgs']) . '</div>';
}

$content = <<<HTML
<html>
	<head>
		<title>Buzer-Plugin (de)installieren</title>
	</head>
	<body style="padding:10px;">
		<div style=""> Mit diesem Skript können Sie das Plugin installieren und wieder entfernen</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Installation</b><br /><br />
			Vor der Installation müssen Sie die im Zip-File enthaltene Datei '$buzerconfig[buzer]' in das Stammverzeichnis Ihrer phpBB-Installation kopiert haben.<br /><br />
			<form action="">
				vom Forum verwendetes Charset <input type="text" name="charset" value="$buzerconfig[charset]"> (2.x wahrscheinlich 'iso-8859-1', 3.x wahrscheinlich 'utf-8')<br />
				<input type="submit" value="jetzt installieren">
				<input type="hidden" name="install" value="1">
			</form>
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Deinstallation</b><br /><br />
			Es wird die bei der Installation als '$buzerconfig[backup]' gesicherte '$buzerconfig[in]' wiederhergestellt<br /><br />
			<form action="">
				<input type="submit" value="jetzt deinstallieren">
				<input type="hidden" name="deinstall" value="1">
			</form>
			
		</div>
		<div style="margin-top:20px;padding:5px;border:1px solid #000000;"><b>Ergebnis:</b><br />
			$install
			$deinstall<br />
			$msg<br /><br />
			$error<br /><br />
		</div>
	</body>
</html>
HTML;

echo $content;

function deinstall(&$buzerconfig) {

	
	if (!is_writeable( "./")) { 
		array_push($buzerconfig['errors'], "Verzeichnis './' nicht schreibbar");
		return 0;
	}

	if ( !is_file( $buzerconfig['backup'])) {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[backup]' nicht gefunden");
		return 0;
	}
	
	if ( !is_writeable( $buzerconfig['backup'])) {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[backup]' nicht schreibbar");
		return 0;
	}
	
	if ( !is_writeable( $buzerconfig['in'])) {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[in]' nicht schreibbar");
		return 0;
	}
	
	if ( is_file($buzerconfig['out']) ) {
		if (!is_writeable( $buzerconfig['out'])) {
			array_push($buzerconfig['errors'], "Datei '$buzerconfig[out]' nicht schreibbar");
			return 0;
		} else {
			if ( !unlink($buzerconfig['out']) ) {
				array_push($buzerconfig['errors'], "Datei '$buzerconfig[out]' nicht löschbar");
				return 0;
			}
		}
	} 
	
	# Tabelle erzeugen
	global $db;

	# anlegen cache
	if ( !$db->sql_query( 'drop table buzer_cache', false)) {
		array_push($buzerconfig['errors'], "Cache-Tabelle 'buzer_cache' konnte nicht entfernt werden");
		return 0;
	} else {
		array_push($buzerconfig['msgs'], "Cache-Tabelle 'buzer_cache' entfernt");
	}

	$rename = rename( $buzerconfig['in'], $buzerconfig['out'] );
	if ( $rename ) {
		array_push($buzerconfig['msgs'], "Datei '$buzerconfig[in]' verschoben nach '$buzerconfig[out]'");
	} else {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[in]' konnte nicht nach '$buzerconfig[out]' verschoben werden");
		return 0;
	}
	
	$rename = rename( $buzerconfig['backup'], $buzerconfig['in'] );
	if ( $rename ) {
		array_push($buzerconfig['msgs'], "Datei '$buzerconfig[backup]' wiederhergestellt als '$buzerconfig[in]'");
	} else {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[backup]' konnte nicht als '$buzerconfig[in]' wiederhergestellt werden");
	}
	
	return $rename;
}


function install(&$buzerconfig) {

	if ( !is_writeable( $buzerconfig['in'])) {
		array_push($buzerconfig['errors'], "Datei '$buzerconfig[in]' nicht schreibbar");
		return 0;
	}
	if ( !is_writeable( "./")) {
		array_push($buzerconfig['errors'], "im Verzeichnis kann './' nicht geschrieben werden");
		return 0;
	}
	if ( is_file($buzerconfig['out']) and !is_writeable( $buzerconfig['out'])) {
		array_push($buzerconfig['errors'], "die Datei '$buzerconfig[out]' nicht geschrieben werden");
		return 0;
	}
	if ( !is_file($buzerconfig['buzer'])) {
		array_push($buzerconfig['errors'], "die Datei '$buzerconfig[buzer]' wurde nicht gefunden");
		return 0;
	}
	if ( !is_readable($buzerconfig['buzer'])) {
		array_push($buzerconfig['errors'], "die Datei '$buzerconfig[buzer]' ist nicht lesbar");
		return 0;
	}
	
	# Tabelle erzeugen
	global $db;
	global $config;

	# anlegen cache
	if ( !$db->sql_query( 'create table if not exists buzer_cache (id int primary key, hash varchar(32), cache mediumtext not null, dateinsert datetime, dateupdate datetime, state tinyint, unique index pk_buzer_cache_hash (hash))', false)) {
		array_push($buzerconfig['errors'], "cache Tabelle konnte nicht erzeugt werden");
		return 0;
	} else {
		array_push($buzerconfig['msgs'], "Cache-Tabelle 'buzer_cache' erzeugt");
	}

		
	# ermitteln der letzten Post-ID
	$result = $db->sql_query( "select max(cast(post_id as signed)-100000) maxid from ". POSTS_TABLE);
	$maxid = $db->sql_fetchrow($result)['maxid'];
	$db->sql_freeresult($result);
	
	$db->sql_query("delete from ".CONFIG_TABLE." where config_name='buzer_cache_table'");
	$config->set('buzer_cache_table', 'buzer_cache');
	$config->set('buzer_max_postid', ($maxid<1 ? 1 : $maxid));
	
	
	$fin 		= fopen($buzerconfig['in'], 'r');
	$fout 		= fopen($buzerconfig['out'], 'w');
	$include	= '';
	$set		= '';

	while ( $line = fgets($fin )) {

		if ( !$include and preg_match( '/^(\s*include\s*\(\s*\$.*)(includes\/bbcode\.\'\s*\.\s*\$phpEx\s*\)\s*;)/',$line, $treffer )) {
			# eintragen des includes
			fwrite( $fout, $line);
			fwrite( $fout, "$treffer[1]$buzerconfig[buzer]');\n");
			$include = "Datei '$buzerconfig[out]': Einfügen der Zeile '$treffer[1]$buzerconfig[buzer]');'";
			array_push($buzerconfig['msgs'], $include);
			
		} elseif ( $include and !$set and preg_match( '/^(\s*\'MESSAGE\'\s*\=\>\s*)\$message\s*,/',$line, $treffer )) {
			# eintragen aufruf der linkfunktion
			fwrite( $fout, "# $line");
			$set = "Datei '$buzerconfig[out]': Auskommentieren der Zeile '$line'";
			array_push($buzerconfig['msgs'], $set);
			#fwrite( $fout, "$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$buzerconfig[charset]'),\n");
			$flineout = "$treffer[1] (\$config['buzer_max_postid'] and \$config['buzer_max_postid']<\$row['post_id']) ? \$gBuzer->buzer_LinkIt(\$message, '$buzerconfig[charset]', \$row['post_id']) : \$message,";
			fwrite( $fout, "$flineout\n");			
			#$set = "Datei '$buzerconfig[out]': Einfügen der Zeile '$treffer[1]buzer_LinkIt(\$message, \$row['post_id'], '$buzerconfig[charset]'),'";
			$set = "Datei '$buzerconfig[out]': Einfügen der Zeile '$flineout'";			
			array_push($buzerconfig['msgs'], $set);
			
		} else {
			fwrite( $fout, $line);
		}
		

	}
	fclose($fout);
	fclose($fin);
	
	if ( !$include ) {
		array_push($buzerconfig['errors'], "die Position zum Einfügen der 'include'-Zeile wurde nicht gefunden");
	}
	if ( !$set ) {
		array_push($buzerconfig['errors'], "die Position zum Einfügen der 'linkIt'-Zeile wurde nicht gefunden");
	}
	
	
	if ( $include and $set ) {
		# sichern der originaldatei und übernehmen der geänderten
		$mv_backup = rename( $buzerconfig['in'], $buzerconfig['backup']);
		if ( $mv_backup	) {
			array_push($buzerconfig['msgs'], "Datei '$buzerconfig[in]' wurde in '$buzerconfig[backup]' umbenannt (Backup)");
		} else {
			array_push( $buzerconfig['errors'], "Datei '$buzerconfig[in]' konnte nicht in '$buzerconfig[backup]' umbenannt werden (Backup)");
		}
		if ( $mv_backup ) {
			$mv_new = rename( $buzerconfig['out'], $buzerconfig['in']);
			if ( $mv_new ) {
				array_push( $buzerconfig['msgs'], "Datei '$buzerconfig[out]' wurde in '$buzerconfig[in]' umbenannt (Hook)");
			} else {
				array_push( $buzerconfig['errors'], "Datei '$buzerconfig[out]' konnte nicht in '$buzerconfig[in]' umbenannt werden (Hook)");
			}
		}
		
		return ($mv_backup and $mv_new);
	}
}

?>